// hyp2f1.cpp : Defines the entry point for the DLL application.

#include "stdafx.h"
#include "hyp2f1.h"

int _tmain(int argc, _TCHAR* argv[])
{
  return 0;
}

extern "C" __declspec( dllexport ) 
void __stdcall Gamma_mpl(double *Z, double *R)
{
  cplx z;
  cplx result;

  z = Z[0] + theI*Z[1];

  result = GAMMA(z);

  R[0]= real(result);
  R[1]= imag(result);
}

extern "C" __declspec( dllexport ) 
void __stdcall reciprocalGamma_mpl(double *Z, double *R)
{
  cplx z;
  cplx result;

  z = Z[0] + theI*Z[1];

  result = rGAMMA(z);

  R[0]= real(result);
  R[1]= imag(result);
}

extern "C" __declspec( dllexport ) 
void  __stdcall pow_mpl(double *Z, double *A, double *R)
{
  cplx z;
  cplx a;
  cplx result;

  z = Z[0] + theI*Z[1];
  a = A[0] + theI*A[1];

  result = pow(z,a);

  R[0]= real(result);
  R[1]= imag(result);
}

/*
extern "C" __declspec( dllexport ) 
void  __stdcall reciprocalSin_mpl(double *Z, double *R)
{
  cplx z;
  cplx result;

  z = Z[0] + theI*Z[1];

  result = rSIN(z);

  R[0]= real(result);
  R[1]= imag(result);
}
*/

extern "C" __declspec( dllexport ) 
void __stdcall  hyp2f1_mpl(double *inputArray, double *resultArray)
{
  cplx a,b,c,z;
  cplx result;

  a = cplx(inputArray[0],inputArray[1]);
  b = cplx(inputArray[2],inputArray[3]);
  c = cplx(inputArray[4],inputArray[5]);
  z = cplx(inputArray[6],inputArray[7]);

  result = hyp2F1(a,b,c,z);

  resultArray[0]= RE(result);
  resultArray[1]= IM(result);
}

extern "C" __declspec( dllexport ) 
void __stdcall  hyp2f1_regularized_mpl(double *inputArray, double *resultArray)
{
  cplx a,b,c,z;
  cplx result;

  a = cplx(inputArray[0],inputArray[1]);
  b = cplx(inputArray[2],inputArray[3]);
  c = cplx(inputArray[4],inputArray[5]);
  z = cplx(inputArray[6],inputArray[7]);

  result = hyp2F1_regularized(a,b,c,z); // 2F1(a,b,c,z)/Gamma(c)

  resultArray[0]= RE(result);
  resultArray[1]= IM(result);
}


// interface for Excel ####################################################
extern "C" __declspec( dllexport ) 
cplx_structure __stdcall Gamma_xl(
  double reZ, 
  double imZ)
{
  cplx z;
  cplx result;
  cplx_structure Result;

  z = reZ + imZ * theI;

  result = GAMMA(z);

  Result.re= real(result);
  Result.im= imag(result);

  return (Result);
}

extern "C" __declspec( dllexport ) 
cplx_structure __stdcall hyp2f1_xl(     
  double reA, double imA, 
  double reB, double imB,
  double reC, double imC,
  double reZ, double imZ)
{
  cplx a,b,c,z;
  cplx result;
  cplx_structure Result;

  a = cplx(reA,imA);
  b = cplx(reB,imB);
  c = cplx(reC,imC);
  z = cplx(reZ,imZ);

  if ( fabs(imZ) <= 1e-306)
    z = cplx(reZ, - (1e-306));

  result = G_2F1(a,b,c,z);

  Result.re= real(result);
  Result.im= imag(result);

  if ( fabs(Result.im) <= 1e-300)
    Result.im = 0.0;

  return (Result);
}
